/*
 * talkatu
 * Copyright (C) 2017-2018 Gary Kramlich <grim@reaperworld.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TALKATU_DEMO_MESSAGE_H
#define TALKATU_DEMO_MESSAGE_H

#include <glib.h>
#include <glib-object.h>

#define TALKATU_TYPE_DEMO_MESSAGE            (talkatu_demo_message_get_type())
#define TALKATU_DEMO_MESSAGE(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), TALKATU_TYPE_DEMO_MESSAGE, TalkatuDemoMessage))
#define TALKATU_DEMO_MESSAGE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), TALKATU_TYPE_DEMO_MESSAGE, TalkatuDemoMessageClass))
#define TALKATU_IS_DEMO_MESSAGE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), TALKATU_TYPE_DEMO_MESSAGE))
#define TALKATU_IS_DEMO_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), TALKATU_TYPE_DEMO_MESSAGE))
#define TALKATU_DEMO_MESSAGE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), TALKATU_TYPE_DEMO_MESSAGE, TalkatuDemoMessageClass))

typedef struct _TalkatuDemoMessage           TalkatuDemoMessage;
typedef struct _TalkatuDemoMessageClass      TalkatuDemoMessageClass;

#include <talkatu/talkatu.h>

struct _TalkatuDemoMessage {
	GObject parent;

	void (*_talkatu_reserved1)(void);
	void (*_talkatu_reserved2)(void);
	void (*_talkatu_reserved3)(void);
	void (*_talkatu_reserved4)(void);
};

struct _TalkatuDemoMessageClass {
	GObjectClass parent;

	void (*_talkatu_reserved1)(void);
	void (*_talkatu_reserved2)(void);
	void (*_talkatu_reserved3)(void);
	void (*_talkatu_reserved4)(void);
};

G_BEGIN_DECLS

GType talkatu_demo_message_get_type(void);

TalkatuMessage *talkatu_demo_message_new(guint64 id, TalkatuContentType content_type, const gchar *author, const gchar *message);

G_END_DECLS

#endif /* TALKATU_DEMO_MESSAGE_H */
