#!/usr/bin/env python3
# talkatu
# Copyright (C) 2017-2018 Gary Kramlich <grim@reaperworld.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <http://www.gnu.org/licenses/>.

"""
This script will run the command specified via command line arguments,
wrapping it with xvfb-run if necessary.
"""

import subprocess
import sys

def need_xvfb():
	needed = ['linux', 'freebsd']

	for need in needed:
		if sys.platform.startswith(need):
			return True

	return False


def main():
	platform = sys.platform

	cmd = sys.argv[1:]

	if need_xvfb():
		cmd = ['xvfb-run', '-a'] + cmd

	proc = subprocess.run(args=cmd)

	sys.exit(proc.returncode)


if __name__ == '__main__':
	main()
